const ytdl  = require('ytdl-core')

const { Playlist } = require('./playlist');

class Player {
  #voice
  #dispatcher
  #playlist
  #gmanager

  constructor(gmanager) {
    this.#gmanager = gmanager
    this.#voice = null
    this.#dispatcher = null
    this.#playlist = new Playlist()
  }

  // https://www.youtube.com/watch?v=Yom8nNqmxvQ
  async stream({ url }) {
    const stream = ytdl(url, { filter: 'audioonly' })
    this.#dispatcher = this.#voice.play(stream)
    this.#dispatcher.on('finish', () => this.next())
    return this;
  }

  async add(message, command_params) {
    if (!message.member?.voice?.channel) {
      message.channel.send('Not connected to voice')
      // cannot connect
    } else {
      this.#voice = await message.member.voice.channel.join()
      this.#voice.voice.setSelfDeaf(true)
      this.stream({ url: 'https://www.youtube.com/watch?v=Yom8nNqmxvQ' })
    }
  }
}

module.exports = { Player }
