class Playlist {
  #current_index
  #track_list
  #gmanager

  constructor(gmanager) {
    this.#gmanager = gmanager
    this.#current_index = 0
    this.#track_list = []
  }

  next() {
    return this.#current_index = (this.#current_index + 1) % this.#track_list.length
  }

  previous() {
    return this.#current_index = (this.#current_index - 1 + this.#track_list.length) % this.#track_list.length
  }

  get_current_track() {
    if (this.#current_index >= this.#track_list.length) return null
    return this.#track_list[this.#current_index]
  }

  push(track) {
    this.#track_list.push(track)
    return true
  }

  delete(track_index) {
    if (track_index >= this.#track_list.length) return false
    delete this.#track_list[track_index]
    this.#track_list = this.#track_list.filter(Boolean)
    return true
  }
}

module.exports = { Playlist }
